

// WiFiOpener ESP8266  
//
// This program demonstrates using a WiFiOpener PCB  
// This program allows you to receive the door opening and closing commands. 
// and commands from other services, via UDP protocol
// It read the public IP adrress and send the message to the server dweet.io 
//https://dweet.io/ . Your Public IP address can be retreived by the  Android Application
//which is   able to send data to the PCB the always (300 sec) updated public IP address.
//This avoids using a DNS service
//the PCB connects to the WiFi using the WiFi manager library https://github.com/tzapu/WiFiManager
//****************************By Giovanni Nicola Mastronardo************************************


///////////////an alternative way to millis to use the timer///////////////////////////////


#ifdef ESP8266
extern "C" {
#include "user_interface.h"
}
#endif

extern "C"{
        #include "user_interface.h"
    }
        os_timer_t mTimer;
        bool       _timeout = false;
        void tCallback(void *tCall){
        _timeout = true;
    }

       void usrInit(void){
       os_timer_setfn(&mTimer, tCallback, NULL);
    }

  //////////////////////////////////////////////////////////////////////////////////////////  

#include <FS.h>                   //this needs to be first 
#include <ESP8266WiFi.h>          //https://github.com/esp8266/Arduino
 
#include <WiFiUdp.h>
#include <ESP8266WebServer.h>
#include <WiFiManager.h>
#include <WiFiClient.h>
 



String dweetThingName("MypublicIP");// dweet name
unsigned int port=39999; // UDP PORT
char packetBuffer[255];
 
WiFiUDP Udp;
    int up = 0; 
    int down = 0;
    int alt = 0;
    int timingup = 0;
    int timingdown = 0;
    int timingupsec = 0;
    int timingdownsec = 0;
    int courtesylampon=0;
    int courtesylampoff=0;
const int Motor_Out_Up = 14;
const int Motor_Out_Down = 5;
const int Blinking_Lamp_Out = 12;
const int Courtesy_Lamp_Out = 13;
const int IRsensor_Input=4;
 
unsigned long  ReadMillis=0;
unsigned long  IPrefreshPrevioustTime=0;
const long     IPrefreshInterval=300000; // dweet refresh time
unsigned long PreviousBlinkingMillis=0;
int updownstatus=0;
int downstatus=0;
int Interval_Open_Close=500;
const long BlinkingSquareTimeMillis=500;
int Blinkstate=LOW;



void setup() {

usrInit();

//pins definitions

  pinMode(Motor_Out_Up, OUTPUT);
  pinMode(Motor_Out_Down, OUTPUT);
  pinMode(Blinking_Lamp_Out, OUTPUT);
  pinMode(Courtesy_Lamp_Out, OUTPUT);
  pinMode(IRsensor_Input, INPUT);
  digitalWrite (Motor_Out_Up, 0);
  digitalWrite (Motor_Out_Down, 0);
  WiFi.hostname("HitecsWiFiOpener"); // hostname
  
 //***************************************************************
 
 //https://github.com/tzapu/WiFiManager
 
   WiFi.mode(WIFI_STA); // explicitly set mode, esp defaults to STA+AP
   Serial.begin(115200);
   WiFiManager wm;
   bool res;
   res = wm.autoConnect("AutoConnectAP","password"); // password protected ap
   if(!res) {
   Serial.println("Failed to connect");
   }
    else {
    Serial.println("connected...yeey :)");
    }
   
 //****************************************************************
 
 
 Udp.begin(port); 
 Serial.println("USP Server started");

  // Print the IP address
  
  Serial.println(WiFi.localIP());
 }

 
//**************************dweet for public IP adderss**************************

String getIp()
  {
  WiFiClient client;
  if (client.connect("api.ipify.org", 80)) 
  {
      Serial.println("connected");
      client.println("GET / HTTP/1.0");
      client.println("Host: api.ipify.org");
      client.println();
  } else {
      Serial.println("Connection to ipify.org failed");
      return String();
  }
  delay(1000);
  String line;
  while(client.available())
  {
    line = client.readStringUntil('\n');
    Serial.println(line);
  }
  return line;
}


bool dweet( String ip)
{

  WiFiClient client;
  if (!client.connect("dweet.io", 80)) 
  {
    Serial.println("dweet failed");
    return false;
  }  
  else 
  {
    Serial.println("dweeting ip address as " + dweetThingName +" [" + ip + "]" );
    
    client.println( String("GET /dweet/for/" + dweetThingName + "?IPaddress=") + ip + " HTTP/1.1");
    client.println( "Host: dweet.io" );
    client.println( "Connection: close");
    client.println("");
    client.println("");
    delay(1000);
  
    // Read all the lines of the reply from server and print them to Serial
    while(client.available())
    {
      String line = client.readStringUntil('\r');
      Serial.print(line);
    };
    return true;
  }; 
    
}

//********************************************************************************

 
void loop() {
 
  
if (digitalRead(IRsensor_Input)== HIGH  && (downstatus==1)){
 os_timer_arm(&mTimer, timingupsec, true); 
     updownstatus=1;
     digitalWrite (Motor_Out_Down, 0);
     delay(Interval_Open_Close);
     digitalWrite (Motor_Out_Up, 1);
}
ReadMillis=millis();

if (ReadMillis - PreviousBlinkingMillis >= BlinkingSquareTimeMillis){
           PreviousBlinkingMillis = ReadMillis;  
if(updownstatus==1)
{    
    if(Blinkstate == LOW) 
      Blinkstate =  HIGH; 
      else
      Blinkstate=LOW;
      digitalWrite (Blinking_Lamp_Out, Blinkstate); 
    }
}
if(ReadMillis -IPrefreshPrevioustTime >=IPrefreshInterval){
  if(updownstatus==0){
  IPrefreshPrevioustTime= ReadMillis;
 String ip = getIp();
 if ( ip != String() )
 dweet( ip ) ;
  }  
 }
  
 
 if (_timeout){
        digitalWrite(Motor_Out_Up, 0);  
        digitalWrite(Motor_Out_Down, 0); 
        digitalWrite (Blinking_Lamp_Out,0);
        updownstatus=0;
        downstatus=0;
          _timeout = false;
 }
  
  int packetSize = Udp.parsePacket();
  if(packetSize) {
    Serial.print("Received packet of size ");
    Serial.println(packetSize);
    Serial.print("From ");
    IPAddress remoteIp = Udp.remoteIP();
    Serial.print(remoteIp);
    Serial.print(", port ");
    Serial.println(Udp.remotePort());

    // read the packet into packetBuffer
    int len = Udp.read(packetBuffer, 255);
    if (len > 0) {
      packetBuffer[len] = 0;
    }    
    Serial.println("Contents:");
    Serial.println(packetBuffer);
    Serial.write(packetBuffer);
    Serial.println();

    // TEMP parse data from packet
    char * temp;
    Serial.print("Splitting string \"");
    Serial.print(packetBuffer);
    Serial.println("\"");

    

    temp = strtok (packetBuffer,":");
    Serial.println(temp);
    up = atoi(temp);

    if(temp != NULL){
     temp = strtok (NULL,":");
      Serial.println(temp);
      down = atoi(temp);
    }

      if(temp != NULL){
      temp = strtok (NULL,":");
      Serial.println(temp);
      alt = atoi(temp);
    }

 if(temp != NULL){
      temp = strtok (NULL,":");
      Serial.println(temp);
      timingup = atoi(temp);
    }

 if(temp != NULL){
      temp = strtok (NULL,":");
      Serial.println(temp);
      timingdown = atoi(temp);
    }

if(temp != NULL){
      temp = strtok (NULL,":");
      Serial.println(temp);
      courtesylampon = atoi(temp);
    }

 if(temp != NULL){
      temp = strtok (NULL,":");
      Serial.println(temp);
      courtesylampoff = atoi(temp);
    }   

    

   timingupsec = timingup*1000;
   timingdownsec = timingdown*1000;  
      
 
     if (up == 1){ 
     os_timer_arm(&mTimer, timingupsec, true); 
     updownstatus=1;
     digitalWrite (Motor_Out_Down, 0);
     delay(Interval_Open_Close);
     digitalWrite (Motor_Out_Up, 1); 
     downstatus=0;
      }


     if (down == 2) { 
     os_timer_arm(&mTimer, timingdownsec, true); 
     updownstatus=1;
     digitalWrite (Motor_Out_Up, 0);
     delay(Interval_Open_Close); 
     digitalWrite (Motor_Out_Down, 1);
      downstatus=1;
     }
   
      if (alt == 3) { 
     digitalWrite (Motor_Out_Down, 0);
     digitalWrite (Motor_Out_Up, 0);
     digitalWrite (Blinking_Lamp_Out,0);
      updownstatus=0;
      downstatus=0;
      }


      if (courtesylampon == 4) { 
     digitalWrite (Courtesy_Lamp_Out, 1);
      }

      if (courtesylampoff == 5) { 
     digitalWrite (Courtesy_Lamp_Out, 0);
      }
    }
 }
  

 
